; List concatenation identities

(defun app (a b)
  (if (consp a)
      (cons (car a) (app (cdr a) b))
    b))

(defun dup (x)
  (if (consp x)
      (cons (car x)
            (cons (car x)
                  (dup (cdr x))))
    nil))

(defun properp (x)
  (if (consp x)
      (properp (cdr x))
    (equal x nil)))

(defthm assoc-app
  (equal (app (app a b) c) (app a (app b c))))
(defthm distrib-app-dup
  (equal (app (dup a) (dup b)) (dup (app a b))))
(defthm properp-app
  (properp (app a nil)))
